﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace 参数传递
{
    class Program
    {
        static void Main(string[] args)
        { 
            #region 按值传递
            // 1. 值类型按值传递情况
            //Console.WriteLine("按值传递的情况");
            //int addNum = 1;
            //Add(addNum);
            //Console.WriteLine(addNum);

            // 2. 引用类型按值传递情况
            //RefClass refClass = new RefClass();
            //AddRef(refClass);
            //Console.WriteLine(refClass.addnum);

            // 3. String引用类型的按值传递的特殊情况
            //string str = "old string";
            //ChangeStr(str);
            //Console.WriteLine(str);
            #endregion 

            #region 按引用传递
            Console.WriteLine("按引用传递的情况");
            int num = 1;
            string refStr = "Old string";
            ChangeByValue(ref num);
            Console.WriteLine(num);
            changeByRef(ref refStr);
            Console.WriteLine(refStr);
            #endregion 

            Console.Read();
        }

        #region 按值传递

        // 1. 值类型按值传递情况
        private static void Add(int addnum)
        {
            addnum = addnum + 1;
            Console.WriteLine(addnum);
        }

        // 2. 引用类型按值传递情况
        private static void AddRef(RefClass addnumRef)
        {
            addnumRef.addnum += 1;
            Console.WriteLine(addnumRef.addnum);
        }

        // 3. String引用类型的按值传递的特殊情况
        private static void ChangeStr(string oldStr)
        {
            oldStr = "New string";
            Console.WriteLine(oldStr);
        }

        #endregion

        #region 按引用传递
        // 1. 值类型的按引用传递情况
        private static void ChangeByValue(ref int numValue)
        {
            numValue = 10;
            Console.WriteLine(numValue);
        }

        // 2. 引用类型的按引用传递情况
        private static void changeByRef(ref string numRef)
        {
            numRef = "new string";
            Console.WriteLine(numRef);
        }

        #endregion

        #region CLR 允许out或ref参数来实现方法重载
        private static void Add(string str)
        {
            Console.WriteLine(str);
        }

        private static void Add(ref string str)
        {
            Console.WriteLine(str);
        }
        #endregion
    }

    class RefClass
    {
        public int addnum=1;
    }
}
